<template>
  <section class="bg-gray-600 items-center justify-center relative" :class="$mq | mq({ sm: 'hidden', md: 'flex' })">
    <div class="wrapper--input absolute p-4 pt-8 top-0 w-full">
      <Search />
    </div>
    <div class="h-full w-full">
      <client-only>
        <gmap-map ref="gmaps" :center="center" :map-type-id="mapTypeId" :zoom="5">
          <gmap-cluster :zoom-on-click="true">
            <gmap-marker
              v-for="item in markers"
              :key="item._id"
              :position="item.latLng"
              :clickable="true"
              @click="toggleInfoWindow(item)"
            />
          </gmap-cluster>
          <InfoWindow
            v-if="focusedItem !== null"
            :options="infoOptions"
            :position="getLatLngFromItem(focusedItem)"
            :opened="infoWindowOpen"
            :content-data="focusedItem"
            @closeclick="infoWindowOpen = false"
          />
        </gmap-map>
      </client-only>
    </div>
  </section>
</template>

<script>
const Search = () => import('~/components/Search');
const InfoWindow = () => import('~/components/Maps/info-window');
import { mapState, mapGetters } from 'vuex';

export default {
  components: {
    Search,
    InfoWindow,
  },
  data() {
    return {
      center: {
        lat: -6.17311,
        lng: 106.829361,
      },
      bounds: null,
      mapTypeId: 'terrain',
      google: null,
      infoWindowOpen: false,
      infoOptions: {
        pixelOffset: {
          width: 0,
          height: -35,
        },
      },
      focusedItem: null,
    };
  },
  computed: {
    ...mapState({
      loading: state => state.beneficiaryList.loading,
      listData: state => state.beneficiaryList.list_data,
      // listData: state => state.beneficiaryList.dummy_list_data,
    }),
    ...mapGetters({
      markers: 'beneficiaryList/map/markers',
    }),
    geojson() {
      return {
        type: 'Feature',
        properties: {
          name: 'Coors Field',
          amenity: 'Baseball Stadium',
          popupContent: 'This is where the Rockies play!',
        },
        geometry: {
          type: 'Point',
          coordinates: [-6.17311, 106.829361],
        },
      };
    },
  },
  methods: {
    toggleInfoWindow(marker) {
      if (marker) {
        const selecteData = this.listData.find(data => {
          return data._id === marker._id;
        });
        this.focusedItem = selecteData;
      }
      this.infoWindowOpen = !this.infoWindowOpen;
    },
    getLatLngFromItem(item) {
      return {
        lat: item.location.latitude,
        lng: item.location.longitude,
      };
    },
  },
};
</script>

<style lang="scss" scoped>
section {
  width: calc(100% - 443px);
  height: calc(100vh - 80px);
  .wrapper--input {
    z-index: 1000;
  }
}
.vue-map-container {
  height: 99%;
}
</style>
